diff --git a/contrib/ldns/drill/drill.c b/contrib/ldns/drill/drill.c
index 6efd29a5ca..611c81f3a8 100644
--- a/contrib/ldns/drill/drill.c
+++ b/contrib/ldns/drill/drill.c
@@ -59,7 +59,7 @@ usage(FILE *stream, const char *progname)
 	fprintf(stream, "\t-6\t\tstay on ip6\n");
 	fprintf(stream, "\t-a\t\tfallback to EDNS0 and TCP if the answer is truncated\n");
 	fprintf(stream, "\t-b <bufsize>\tuse <bufsize> as the buffer size (defaults to 512 b)\n");
-	fprintf(stream, "\t-c <file>\tuse file for rescursive nameserver configuration"
+	fprintf(stream, "\t-c <file>\tuse file for recursive nameserver configuration"
 			"\n\t\t\t(/etc/resolv.conf)\n");
 	fprintf(stream, "\t-k <file>\tspecify a file that contains a trusted DNSSEC key [**]\n");
 	fprintf(stream, "\t\t\tUsed to verify any signatures in the current answer.\n");
@@ -173,6 +173,8 @@ main(int argc, char *argv[])
 	int r;
 	WSADATA wsa_data;
 #endif
+	ldns_output_format_storage fmt_storage;
+	ldns_output_format* fmt = ldns_output_format_init(&fmt_storage);
 
 	int_type = -1; serv = NULL; type = 0; 
 	int_clas = -1; name = NULL; clas = 0;
@@ -201,6 +203,7 @@ main(int argc, char *argv[])
 	qusevc = false;
 	qrandom = true;
 	key_verified = NULL;
+	ldns_edns_option_list* edns_list = NULL;
 
 	ldns_init_random(NULL, 0);
 
@@ -247,6 +250,7 @@ main(int argc, char *argv[])
 				verbosity = atoi(optarg);
 				break;
 			case 'Q':
+				fmt->flags |= LDNS_FMT_SHORT;
 				verbosity = -1;
 				break;
 			case 'f':
@@ -454,6 +458,31 @@ main(int argc, char *argv[])
 			serv = argv[i] + 1;
 			continue;
 		}
+		/* if ^+ then it's an EDNS option */
+		if (argv[i][0] == '+') {
+			if (!strcmp(argv[i]+1, "nsid")) {
+				ldns_edns_option *edns;
+				edns_list = ldns_edns_option_list_new();
+
+				/* create NSID EDNS*/
+				edns = ldns_edns_new_from_data(LDNS_EDNS_NSID, 0, NULL);
+
+				if (edns_list == NULL || edns == NULL) {
+					error("EDNS option could not be allocated");
+					break;
+				}
+
+				if (!(ldns_edns_option_list_push(edns_list, edns))) {
+					error("EDNS option NSID could not be attached");
+					break;
+				}
+				continue;
+			}
+			else {
+				error("Unsupported argument after '+'");
+				break;
+			}
+		}
 		/* if has a dot, it's a name */
 		if (strchr(argv[i], '.')) {
 			name = argv[i];
@@ -793,7 +822,7 @@ main(int argc, char *argv[])
 			}
 			status = ldns_resolver_prepare_query_pkt(&qpkt, res, qname, type, clas, qflags);
 			if(status != LDNS_STATUS_OK) {
-				error("%s", "making query: %s", 
+				error("%s", "making query: %s",
 					ldns_get_errorstr_by_id(status));
 			}
 			dump_hex(qpkt, query_file);
@@ -864,9 +893,22 @@ main(int argc, char *argv[])
 				} else {
 					/* create a packet and set the RD flag on it */
 					pkt = NULL;
-					status = ldns_resolver_query_status(
-							&pkt, res, qname,
-							type, clas, qflags);
+
+					status = ldns_resolver_prepare_query_pkt(&qpkt,
+						res, qname, type, clas, qflags);
+					if(status != LDNS_STATUS_OK) {
+						error("%s", "making query: %s", 
+							ldns_get_errorstr_by_id(status));
+					}
+
+					if (edns_list) {
+						/* attach the structed EDNS options */
+						ldns_pkt_set_edns_option_list(qpkt, edns_list);
+					}
+
+					status = ldns_resolver_send_pkt(&pkt, res, qpkt);
+					ldns_pkt_free(qpkt);
+
 					if (status != LDNS_STATUS_OK) {
 						error("error sending query: %s"
 						     , ldns_get_errorstr_by_id(
@@ -875,12 +917,13 @@ main(int argc, char *argv[])
 				}
 			}
 			
-			if (!pkt)  {
+			/* now handling the response message/packet */
+			if (!pkt) {
 				mesg("No packet received");
 				result = EXIT_FAILURE;
 			} else {
+				ldns_pkt_print_fmt(stdout, fmt, pkt);
 				if (verbosity != -1) {
-					ldns_pkt_print(stdout, pkt);
 					if (ldns_pkt_tc(pkt)) {
 						fprintf(stdout,
 							"\n;; WARNING: The answer packet was truncated; you might want to\n");
@@ -994,9 +1037,17 @@ main(int argc, char *argv[])
 	xfree(tsig_algorithm);
 
 #ifdef HAVE_SSL
-	CRYPTO_cleanup_all_ex_data();
-	ERR_free_strings();
-	EVP_cleanup();
+#if OPENSSL_VERSION_NUMBER < 0x10100000L || defined(HAVE_LIBRESSL)
+#ifdef HAVE_CRYPTO_CLEANUP_ALL_EX_DATA
+	CRYPTO_cleanup_all_ex_data ();
+#endif
+#ifdef HAVE_ERR_FREE_STRINGS
+	ERR_free_strings ();
+#endif
+#ifdef HAVE_EVP_CLEANUP
+	EVP_cleanup ();
+#endif
+#endif
 #endif
 #ifdef USE_WINSOCK
 	WSACleanup();
diff --git a/contrib/ldns/drill/securetrace.c b/contrib/ldns/drill/securetrace.c
index 6967265de5..90014b4e30 100644
--- a/contrib/ldns/drill/securetrace.c
+++ b/contrib/ldns/drill/securetrace.c
@@ -137,7 +137,7 @@ do_secure_trace(ldns_resolver *local_res, ldns_rdf *name, ldns_rr_type t,
 	ldns_rr_list *correct_key_list;
 	ldns_rr_list *trusted_ds_rrs;
 	bool new_keys_trusted = false;
-	ldns_rr_list *current_correct_keys;
+	ldns_rr_list *current_correct_keys = NULL;
 	ldns_rr_list *dataset;
 
 	ldns_rr_list *nsec_rrs = NULL;
@@ -520,8 +520,8 @@ do_secure_trace(ldns_resolver *local_res, ldns_rdf *name, ldns_rr_type t,
 							labels[i-1]);
 						printf(", but valid CNAME");
 					} else {
-						printf("[B] Unable to verify de"
-						       "nial of existence for ");
+						printf(BOGUS " Unable to verify "
+						       "denial of existence for ");
 						ldns_rdf_print(stdout,
 							labels[i-1]);
 						printf(", because of BOGUS CNAME");
@@ -644,7 +644,7 @@ do_secure_trace(ldns_resolver *local_res, ldns_rdf *name, ldns_rr_type t,
 							printf(";; No DS for ");
 							ldns_rdf_print(stdout, labels[i - 1]);
 						} else {
-							printf("[B] Unable to verify denial of existence for ");
+							printf(BOGUS " Unable to verify denial of existence for ");
 							ldns_rdf_print(stdout, labels[i - 1]);
 							printf(" DS: %s\n", ldns_get_errorstr_by_id(status));
 						}
@@ -748,7 +748,7 @@ do_secure_trace(ldns_resolver *local_res, ldns_rdf *name, ldns_rr_type t,
 						}
 						printf("\n");
 					} else {
-						printf("[B] Unable to verify denial of existence for ");
+						printf(BOGUS " Unable to verify denial of existence for ");
 						ldns_rdf_print(stdout, name);
 						printf(" type ");
 						if (descriptor && descriptor->_name) {
@@ -774,7 +774,7 @@ do_secure_trace(ldns_resolver *local_res, ldns_rdf *name, ldns_rr_type t,
 		ldns_rr_list_deep_free(ds_sig_list);
 		ds_sig_list = NULL;
 	}
-	printf(";;" SELF " self sig OK; " BOGUS " bogus; " TRUST " trusted\n");
+	printf(";;" SELF " self sig OK; " BOGUS " bogus; " TRUST " trusted; " UNSIGNED " unsigned\n");
 	/* verbose mode?
 	printf("Trusted keys:\n");
 	ldns_rr_list_print(stdout, trusted_keys);
diff --git a/contrib/ldns/duration.c b/contrib/ldns/duration.c
index 0a8d79b519..abff9a074f 100644
--- a/contrib/ldns/duration.c
+++ b/contrib/ldns/duration.c
@@ -190,121 +190,51 @@ ldns_duration_create_from_string(const char* str)
 
 
 /**
- * Get the number of digits in a number.
- *
+ * Helper func for ldns_duration2string below. If t > 0,
+ * scan print t and c on buf, forwarding buf. Return 0 on success.
  */
-static size_t
-digits_in_number(time_t duration)
+static inline int dur_scan_print(char **buf, char *eob, char c, time_t t)
 {
-	unsigned int i = (unsigned int) duration;
-	size_t n = 1;
-
-	while (i >= 100000000) {
-		n += 8;
-		i /= 100000000;
+	if (t > 0) {
+		int r = snprintf(*buf, eob - *buf, "%u%c", (unsigned)t, c);
+		if (r < 0 || (*buf += r) >= eob)
+			return -1;
 	}
-	if (i >= 10000) { n += 4; i /= 10000; }
-	if (i >= 100  ) { n += 2; i /= 100; }
-	if (i >= 10   ) { n += 1; }
-	return n;
+	return 0;
 }
 
-
 /**
  * Convert a duration to a string.
  *
  */
 char*
-ldns_duration2string(const ldns_duration_type* duration)
+ldns_duration2string(const ldns_duration_type* d)
 {
-    char* str = NULL;
-    size_t count = 2;
-    int T = 0;
-    char num[sizeof(unsigned int) + 2];
-
-    if (!duration) {
-        return NULL;
-    }
-
-    if (duration->years > 0) {
-        count = count + 1 + digits_in_number(duration->years);
-    }
-    if (duration->months > 0) {
-        count = count + 1 + digits_in_number(duration->months);
-    }
-    if (duration->weeks > 0) {
-        count = count + 1 + digits_in_number(duration->weeks);
-    }
-    if (duration->days > 0) {
-        count = count + 1 + digits_in_number(duration->days);
-    }
-    if (duration->hours > 0) {
-        count = count + 1 + digits_in_number(duration->hours);
-        T = 1;
-    }
-    if (duration->minutes > 0) {
-        count = count + 1 + digits_in_number(duration->minutes);
-        T = 1;
-    }
-    if (duration->seconds > 0) {
-        count = count + 1 + digits_in_number(duration->seconds);
-        T = 1;
-    }
-    if (T) {
-        count++;
-    }
-
-    if (!(str = (char*) calloc(count, sizeof(char))))
-	    return NULL;
-    str[0] = 'P';
-    str[1] = '\0';
-
-    if (duration->years > 0) {
-        count = digits_in_number(duration->years);
-	assert(count <= sizeof(num) - 2);
-        snprintf(num, count+2, "%uY", (unsigned int) duration->years);
-        str = strncat(str, num, count+2);
-    }
-    if (duration->months > 0) {
-        count = digits_in_number(duration->months);
-	assert(count <= sizeof(num) - 2);
-        snprintf(num, count+2, "%uM", (unsigned int) duration->months);
-        str = strncat(str, num, count+2);
-    }
-    if (duration->weeks > 0) {
-        count = digits_in_number(duration->weeks);
-	assert(count <= sizeof(num) - 2);
-        snprintf(num, count+2, "%uW", (unsigned int) duration->weeks);
-        str = strncat(str, num, count+2);
-    }
-    if (duration->days > 0) {
-        count = digits_in_number(duration->days);
-	assert(count <= sizeof(num) - 2);
-        snprintf(num, count+2, "%uD", (unsigned int) duration->days);
-        str = strncat(str, num, count+2);
-    }
-    if (T) {
-        str = strcat(str, "T");
-    }
-    if (duration->hours > 0) {
-        count = digits_in_number(duration->hours);
-	assert(count <= sizeof(num) - 2);
-        snprintf(num, count+2, "%uH", (unsigned int) duration->hours);
-        str = strncat(str, num, count+2);
-    }
-    if (duration->minutes > 0) {
-        count = digits_in_number(duration->minutes);
-	assert(count <= sizeof(num) - 2);
-        snprintf(num, count+2, "%uM", (unsigned int) duration->minutes);
-        str = strncat(str, num, count+2);
-    }
-    if (duration->seconds > 0) {
-        count = digits_in_number(duration->seconds);
-	assert(count <= sizeof(num) - 2);
-        snprintf(num, count+2, "%uS", (unsigned int) duration->seconds);
-        str = strncat(str, num, count+2);
-    }
-    return str;
+ 	/* Max string size should be 7 * 40 + 3 on a 127 bits machine
+	 * So 300 (< 273) is more than enough.
+	 */
+	char buf[300] = "P0D", *eob = buf + sizeof(buf), *p = buf + 1;
+
+	if (!d)
+		return NULL;
+
+	if (dur_scan_print(&p, eob, 'Y', d->years)
+	||  dur_scan_print(&p, eob, 'M', d->months)
+	||  dur_scan_print(&p, eob, 'W', d->weeks)
+	||  dur_scan_print(&p, eob, 'D', d->days))
+		return NULL;
+
+	if (d->hours || d->minutes || d->seconds) {
+		if (p > (eob - 2))
+			return NULL; /* Error; no space left on buf for 'T' */
+
+		*p++ = 'T'; *p = 0;
+		if (dur_scan_print(&p, eob, 'H', d->hours)
+		||  dur_scan_print(&p, eob, 'M', d->minutes)
+		||  dur_scan_print(&p, eob, 'S', d->seconds))
+			return NULL;
+	}
+	return strdup(buf);
 }
 
 
diff --git a/contrib/ldns/edns.c b/contrib/ldns/edns.c
new file mode 100644
index 0000000000..3d002d67ed
--- /dev/null
+++ b/contrib/ldns/edns.c
@@ -0,0 +1,436 @@
+/*
+ * edns.c
+ *
+ * edns implementation
+ *
+ * a Net::DNS like library for C
+ *
+ * (c) NLnet Labs, 2004-2022
+ *
+ * See the file LICENSE for the license
+ */
+
+#include <ldns/ldns.h>
+
+#define LDNS_OPTIONLIST_INIT 8
+
+/*
+ * Access functions
+ * functions to get and set type checking
+ */
+
+/* read */
+size_t
+ldns_edns_get_size(const ldns_edns_option *edns)
+{
+	assert(edns != NULL);
+	return edns->_size;
+}
+
+ldns_edns_option_code
+ldns_edns_get_code(const ldns_edns_option *edns)
+{
+	assert(edns != NULL);
+	return edns->_code;
+}
+
+uint8_t *
+ldns_edns_get_data(const ldns_edns_option *edns)
+{
+	assert(edns != NULL);
+	return edns->_data;
+}
+
+ldns_buffer *
+ldns_edns_get_wireformat_buffer(const ldns_edns_option *edns)
+{
+	uint16_t option;
+	size_t size;
+	uint8_t* data;
+	ldns_buffer* buffer;
+
+	if (edns == NULL) {
+		return NULL;
+	}
+
+	option = ldns_edns_get_code(edns);
+	size = ldns_edns_get_size(edns);
+	data = ldns_edns_get_data(edns);
+
+	buffer = ldns_buffer_new(size + 4);
+
+	if (buffer == NULL) {
+		return NULL;
+	}
+
+	ldns_buffer_write_u16(buffer, option);
+	ldns_buffer_write_u16(buffer, size);
+	ldns_buffer_write(buffer, data, size);
+
+	ldns_buffer_flip(buffer);
+
+	return buffer;
+}
+
+/* write */
+void
+ldns_edns_set_size(ldns_edns_option *edns, size_t size)
+{
+	assert(edns != NULL);
+	edns->_size = size;
+}
+
+void
+ldns_edns_set_code(ldns_edns_option *edns, ldns_edns_option_code code)
+{
+	assert(edns != NULL);
+	edns->_code = code;
+}
+
+void
+ldns_edns_set_data(ldns_edns_option *edns, void *data)
+{
+	/* only copy the pointer */
+	assert(edns != NULL);
+	edns->_data = data;
+}
+
+/* note: data must be allocated memory */
+ldns_edns_option *
+ldns_edns_new(ldns_edns_option_code code, size_t size, void *data)
+{
+	ldns_edns_option *edns;
+	edns = LDNS_MALLOC(ldns_edns_option);
+	if (!edns) {
+		return NULL;
+	}
+	ldns_edns_set_code(edns, code);
+	ldns_edns_set_size(edns, size);
+	ldns_edns_set_data(edns, data);
+
+	return edns;
+}
+
+ldns_edns_option *
+ldns_edns_new_from_data(ldns_edns_option_code code, size_t size, const void *data)
+{
+	ldns_edns_option *edns;
+	edns = LDNS_MALLOC(ldns_edns_option);
+	if (!edns) {
+		return NULL;
+	}
+	edns->_data = LDNS_XMALLOC(uint8_t, size);
+	if (!edns->_data) {
+		LDNS_FREE(edns);
+		return NULL;
+	}
+
+	/* set the values */
+	ldns_edns_set_code(edns, code);
+	ldns_edns_set_size(edns, size);
+	memcpy(edns->_data, data, size);
+
+	return edns;
+}
+
+ldns_edns_option *
+ldns_edns_clone(ldns_edns_option *edns)
+{
+	ldns_edns_option *new_option;
+
+	assert(edns != NULL);
+
+	new_option = ldns_edns_new_from_data(ldns_edns_get_code(edns),
+		ldns_edns_get_size(edns),
+		ldns_edns_get_data(edns));
+
+	return new_option;
+}
+
+void
+ldns_edns_deep_free(ldns_edns_option *edns)
+{
+	if (edns) {
+		if (edns->_data) {
+			LDNS_FREE(edns->_data);
+		}
+		LDNS_FREE(edns);
+	}
+}
+
+void 
+ldns_edns_free(ldns_edns_option *edns)
+{
+	if (edns) {
+		LDNS_FREE(edns);
+	}
+}
+
+ldns_edns_option_list*
+ldns_edns_option_list_new()
+{
+	ldns_edns_option_list *option_list = LDNS_MALLOC(ldns_edns_option_list);
+	if(!option_list) {
+		return NULL;
+	}
+
+	option_list->_option_count = 0;
+	option_list->_option_capacity = 0;
+	option_list->_options_size = 0;
+	option_list->_options = NULL;
+	return option_list;
+}
+
+ldns_edns_option_list *
+ldns_edns_option_list_clone(ldns_edns_option_list *old_list)
+{
+	size_t i;
+	ldns_edns_option_list *new_list;
+
+	if (!old_list) {
+		return NULL;
+	}
+
+	new_list = ldns_edns_option_list_new();
+	if (!new_list) {
+		return NULL;
+	}
+
+	if (old_list->_option_count == 0) {
+		return new_list;
+	}
+
+	/* adding options also updates the total options size */
+	for (i = 0; i < old_list->_option_count; i++) {
+		ldns_edns_option *option = ldns_edns_clone(ldns_edns_option_list_get_option(old_list, i));
+		if (!ldns_edns_option_list_push(new_list, option)) {
+			ldns_edns_deep_free(option);
+			ldns_edns_option_list_deep_free(new_list);
+			return NULL;
+		}
+	}
+	return new_list;
+}
+
+void
+ldns_edns_option_list_free(ldns_edns_option_list *option_list)
+{
+	if (option_list) {
+		LDNS_FREE(option_list->_options);
+		LDNS_FREE(option_list);
+	}
+}
+
+void
+ldns_edns_option_list_deep_free(ldns_edns_option_list *option_list)
+{
+	size_t i;
+
+	if (option_list) {
+		for (i=0; i < ldns_edns_option_list_get_count(option_list); i++) {
+			ldns_edns_deep_free(ldns_edns_option_list_get_option(option_list, i));
+		}
+		ldns_edns_option_list_free(option_list);
+	}
+}
+
+size_t
+ldns_edns_option_list_get_count(const ldns_edns_option_list *option_list)
+{
+	if (option_list) {
+		return option_list->_option_count;
+	} else {
+		return 0;
+	}
+}
+
+ldns_edns_option *
+ldns_edns_option_list_get_option(const ldns_edns_option_list *option_list, size_t index)
+{
+	if (option_list && index < ldns_edns_option_list_get_count(option_list)) {
+		assert(option_list->_options[index]);
+		return option_list->_options[index];
+	} else {
+		return NULL;
+	}
+}
+
+size_t
+ldns_edns_option_list_get_options_size(const ldns_edns_option_list *option_list)
+{
+	if (option_list) {
+		return option_list->_options_size;
+	} else {
+		return 0;
+	}
+}
+
+
+ldns_edns_option *
+ldns_edns_option_list_set_option(ldns_edns_option_list *option_list,
+	ldns_edns_option *option, size_t index)
+{
+	ldns_edns_option* old;
+
+	assert(option_list != NULL);
+
+	if (index > ldns_edns_option_list_get_count(option_list)) {
+		return NULL;
+	}
+
+	if (option == NULL) {
+		return NULL;
+	}
+
+	old = ldns_edns_option_list_get_option(option_list, index);
+
+	/* shrink the total EDNS size if the old EDNS option exists */
+	if (old != NULL) {
+		option_list->_options_size -= (ldns_edns_get_size(old) + 4);
+	}
+
+	option_list->_options_size += (ldns_edns_get_size(option) + 4);
+
+	option_list->_options[index] = option;
+	return old;
+}
+
+bool
+ldns_edns_option_list_push(ldns_edns_option_list *option_list,
+	ldns_edns_option *option)
+{
+	size_t cap;
+	size_t option_count;
+
+	assert(option_list != NULL);
+
+	if (option == NULL) {
+		return false;
+	}
+
+	cap = option_list->_option_capacity;
+	option_count = ldns_edns_option_list_get_count(option_list);
+
+	/* verify we need to grow the array to fit the new option */
+	if (option_count+1 > cap) {
+		ldns_edns_option **new_list;
+
+		/* initialize the capacity if needed, otherwise grow by doubling */
+		if (cap == 0) {
+			cap = LDNS_OPTIONLIST_INIT; /* initial list size */
+		} else {
+			cap *= 2;
+		}
+
+		new_list = LDNS_XREALLOC(option_list->_options,
+			ldns_edns_option *, cap);
+
+		if (!new_list) {
+			return false;
+		}
+
+		option_list->_options = new_list;
+		option_list->_option_capacity = cap;
+	}
+
+	/* add the new option */
+	ldns_edns_option_list_set_option(option_list, option,
+		option_list->_option_count);
+	option_list->_option_count += 1;
+
+	return true;
+}
+
+ldns_edns_option *
+ldns_edns_option_list_pop(ldns_edns_option_list *option_list)
+{
+	ldns_edns_option* pop;
+	size_t count;
+	size_t cap;
+
+	assert(option_list != NULL);
+
+	cap = option_list->_option_capacity;
+	count = ldns_edns_option_list_get_count(option_list);
+
+	if (count == 0) {
+		return NULL;
+	}
+	/* get the last option from the list */
+	pop = ldns_edns_option_list_get_option(option_list, count-1);
+
+	/* shrink the array */
+	if (cap > LDNS_OPTIONLIST_INIT && count-1 <= cap/2) {
+		ldns_edns_option **new_list;
+
+		cap /= 2;
+
+		new_list = LDNS_XREALLOC(option_list->_options,
+			ldns_edns_option *, cap);
+		if (new_list) {
+			option_list->_options = new_list;
+		}
+		/* if the realloc fails, the capacity for the list remains unchanged */
+	}
+
+	/* shrink the total EDNS size of the options if the popped EDNS option exists */
+	if (pop != NULL) {
+		option_list->_options_size -= (ldns_edns_get_size(pop) + 4);
+	}
+
+	option_list->_option_count = count - 1;
+
+	return pop;
+}
+
+ldns_buffer *
+ldns_edns_option_list2wireformat_buffer(const ldns_edns_option_list *option_list)
+{
+	size_t i, list_size, options_size, option, size;
+	ldns_buffer* buffer;
+	ldns_edns_option *edns;
+	uint8_t* data = NULL;
+
+	if (!option_list) {
+		return NULL;
+	}
+
+	/* get the number of EDNS options in the list*/
+	list_size = ldns_edns_option_list_get_count(option_list);
+
+	/* create buffer the size of the total EDNS wireformat options */
+	options_size = ldns_edns_option_list_get_options_size(option_list);
+	buffer = ldns_buffer_new(options_size);
+	
+	if (!buffer) {
+		return NULL;
+	}
+
+	/* write individual serialized EDNS options to final buffer*/
+	for (i = 0; i < list_size; i++) {
+		edns = ldns_edns_option_list_get_option(option_list, i);
+
+		if (edns == NULL) {
+			/* this shouldn't be possible */
+			return NULL;
+		}
+
+		option = ldns_edns_get_code(edns);
+		size = ldns_edns_get_size(edns);
+		data = ldns_edns_get_data(edns);
+
+		/* make sure the option fits */
+		if (!(ldns_buffer_available(buffer, size + 4))) {
+			ldns_buffer_free(buffer);
+			return NULL;
+		}
+
+		ldns_buffer_write_u16(buffer, option);
+		ldns_buffer_write_u16(buffer, size);
+		ldns_buffer_write(buffer, data, size);
+	}
+
+	ldns_buffer_flip(buffer);
+
+	return buffer;
+}
diff --git a/contrib/ldns/error.c b/contrib/ldns/error.c
index 7943017a90..e3fd121127 100644
--- a/contrib/ldns/error.c
+++ b/contrib/ldns/error.c
@@ -1,6 +1,6 @@
 /*
  * a error2str function to make sense of all the
- * error codes we have laying ardoun
+ * error codes we have laying around
  *
  * a Net::DNS like library for C
  * LibDNS Team @ NLnet Labs
@@ -157,6 +157,33 @@ ldns_lookup_table ldns_error_str[] = {
 		"X509_STORE_CTX_set0_dane() functions within OpenSSL >= 1.1.0 "
 		"to be able to verify the DANE-TA usage type." },
 #endif
+	{ LDNS_STATUS_ZONEMD_DOUBLE_OCCURRENCE, "A ZONEMD with the same "
+		"<scheme> and hash algorithm occurred more than once." },
+	{ LDNS_STATUS_ZONEMD_UNKNOWN_SCHEME, "Unknown ZONEMD <scheme>" },
+	{ LDNS_STATUS_ZONEMD_UNKNOWN_HASH, "Unknown ZONEMD hash algorithm" },
+	{ LDNS_STATUS_ZONEMD_INVALID_SOA,
+		"Missing or invalid SOA to associate with ZONEMD RR" },
+	{ LDNS_STATUS_NO_ZONEMD,
+		"NSEC(3) RRs indicate that a ZONEMD exists, "
+	        "but it is not found in the zone" },
+	{ LDNS_STATUS_NO_VALID_ZONEMD,
+		"No ZONEMD matching the zone data was found" },
+	{ LDNS_STATUS_SYNTAX_SVCPARAM_KEY_ERR, "Syntax error in a key in "
+		"the ServiceParam rdata field of SVCB or HTTPS RR" },
+	{ LDNS_STATUS_SYNTAX_SVCPARAM_VALUE_ERR, "Syntax error in a value in "
+		"the ServiceParam rdata field of SVCB or HTTPS RR" },
+	{ LDNS_STATUS_RESERVED_SVCPARAM_KEY,
+		"key65535 is reserved and MUST NOT be used "
+		"in the ServiceParam rdata field of SVCB or HTTPS RR" },
+	{ LDNS_STATUS_NO_SVCPARAM_VALUE_EXPECTED,
+		"A value was found for a key that SHOULD not have a value "
+		"in the ServiceParam rdata field of SVCB or HTTPS RR" },
+	{ LDNS_STATUS_SVCPARAM_KEY_MORE_THAN_ONCE,
+		"A key was found more than once "
+		"in the ServiceParam rdata field of SVCB or HTTPS RR" },
+	{ LDNS_STATUS_INVALID_SVCPARAM_VALUE,
+		"Invalid wireformat of a value "
+		"in the ServiceParam rdata field of SVCB or HTTPS RR" },
 	{ 0, NULL }
 };
 
